%define mod_path /usr/libexec/livestatus
%define nagios_cfg /opt/monitor/etc/nagios.cfg
%define debug_package %{nil}

# prevent stripping of binaries
%define __spec_install_post /usr/lib/rpm/brp-compress

%{?dgroup:%define daemon_group %{dgroup}}

%if ! ( 0%{?rhel} > 5 )
%{!?python_sitelib: %global python_sitelib %(/usr/bin/python26 -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python_sitearch: %global python_sitearch %(/usr/bin/python26 -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%endif

Summary: MK-Livestatus is a module for fetching status data from Nagios
Name: monitor-livestatus
Version: 1.2.5
Release: op5.1
License: GPL
Group: op5/Monitor
URL: http://www.op5.se
Source0: %name-%version.tar.gz
Prefix: /opt/monitor
Requires: monitor
%if ! 0%{?suse_version} && ! ( 0%{?rhel} > 5)
Requires: python26
BuildRequires: python26
%endif
BuildRequires: libstdc++-devel
BuildRequires: gcc-c++
BuildRequires: op5-nagios-devel
BuildRequires: autoconf, automake
BuildRoot: %{_tmppath}/%{name}-%{version}


%description
%name is an eventbroker module for op5 Monitor which allows
external programs to use the running Nagios daemon as a specialized
database. %name is a shallow fork of mk-livestatus by
Mathias Kettner.


%package -n unixcat
Summary: unixcat is a utility used to send data to a unix domain socket
Group: op5/system-addons

%description -n unixcat

%prep
%setup -q


%build
rm -rf %buildroot
aclocal && autoheader && automake -a
# FIXME! We ignore autoconf errors for now since build seems ok.
autoconf || :
./configure CPPFLAGS=-I/opt/monitor/include
make


%install
mkdir -p %buildroot%mod_path
mkdir -p %buildroot%_bindir
cp -a src/livestatus.o %buildroot%mod_path
cp -a src/unixcat %buildroot%_bindir

mkdir -p %buildroot/opt/monitor/op5/livestatus/
ln -s ../../../../usr/libexec/livestatus/livestatus.o %buildroot/opt/monitor/op5/livestatus/livestatus.o

install -d %buildroot%{python_sitelib}/livestatus
install -pm 0644 api/python/livestatus.py %buildroot%{python_sitelib}/livestatus/
install -pm 0644 api/python/__init__.py %buildroot%{python_sitelib}/livestatus/

%post
if ! grep -q 'broker_module.*livestatus\.o' %nagios_cfg; then
	sed -i "s#^log_file.*#broker_module=%mod_path/livestatus.o pnp_path=/opt/monitor/op5/pnp/perfdata /opt/monitor/var/rw/live\\n\\n&#" \
		%nagios_cfg
elif ! grep -q 'broker_module.*livestatus\.o.*pnp_path' %nagios_cfg; then
	sed -i "s#broker_module=%mod_path/livestatus.o#broker_module=%mod_path/livestatus.o pnp_path=/opt/monitor/op5/pnp/perfdata#" \
		%nagios_cfg
elif grep -q 'broker_module.*op5/livestatus/livestatus\.o' %nagios_cfg; then
	sed -i "s#/opt/monitor/op5/livestatus/livestatus\.o#/usr/libexec/livestatus/livestatus.o#" \
		%nagios_cfg
fi
if ! grep -q 'broker_module.*livestatus\.o.*hidden_custom_var_prefix'; then
	sed -i "s#broker_module=%mod_path/livestatus.o#broker_module=%mod_path/livestatus.o hidden_custom_var_prefix=OP5SECRET__#" \
		%nagios_cfg
fi
# we must return/exit with true since yum complains otherwise:
test -f /etc/init.d/monitor && /etc/init.d/monitor restart || :


%postun
# remove module from Nagios cfg if uninstalling
if test $1 -eq 0; then
	sed -i '#^broker_module=%mod_path/livestatus.o#d' %nagios_cfg
fi
# we must return/exit with true since yum complains otherwise:
test -f /etc/init.d/monitor && /etc/init.d/monitor restart || :


%files
%defattr(-,root,root)
%mod_path
/opt/monitor/op5/livestatus/livestatus.o
%{python_sitelib}/livestatus


%files -n unixcat
%defattr(755,root,root)
%_bindir/unixcat


%clean
rm -rf %buildroot

%changelog
* Tue Jun 14 2011 Andreas Ericsson <ae@op5.se>
- Initial specfile creation.
